<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelRentabiProdutoService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function find($TIPOCUSTO, $CDFILIAL, $TCDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN, $PRODNIV, $TCDPRODUTO, $CDPRODLIST, $CDARVPRODF, $CDARVPRODI, $CDNVPRODUTOAGRUP, $FLAGIMPOSTO) {
        $params = array(
         	':TIPOCUSTO' => $TIPOCUSTO,
         	':CDFILIAL' => $CDFILIAL,
         	':TCDFILIAL' => $TCDFILIAL,
         	':NRORG' => $NRORG,
         	':CDLOJA' => $CDLOJA,
            ':TCDLOJA' => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN,
         	':CDNVPRODUTOAGRUP' => $CDNVPRODUTOAGRUP,
         	':PRODNIV' => $PRODNIV,
         	':TCDPRODUTO' => $TCDPRODUTO,
         	':CDPRODLIST' => $CDPRODLIST,
         	':CDARVPRODF' => $CDARVPRODF,
         	':CDARVPRODI' => $CDARVPRODI
 		);
 		if ($FLAGIMPOSTO == 'C') {
 		    return $this->entityManager->getConnection()->fetchAll(self::GET_RENTABILIDADE_PRODUTO, $params);
 		}else {
 		    return $this->entityManager->getConnection()->fetchAll(self::GET_RENTABILIDADE_PRODUTO_SEM_IMPOSTO, $params);
 		}
    }

    const GET_RENTABILIDADE_PRODUTO = "
        SELECT CDFILIAL||' - '||NMFILIAL AS LABELFILIAL,
        		CDLOJA||' - '||NMLOJA AS LABELLOJA,
        		CDFILIAL, NMFILIAL, CDLOJA, NMLOJA, CDPRODUTO, CDARVPROD, NMPRODUTO, VRUNITVEND, CDPRODUTOAVO, NMPRODUTOAVO,
        		SUM(QTPRODVEND) AS QTPRODVEND, 
        		SUM(VRIMPOSTO) AS VRIMPOSTO,
        		SUM(VRTOTAL) AS VRTOTAL,
        		SUM(VRCUSTO) AS VRCUSTO,
        		SUM(VRTOTAL) - SUM(VRIMPOSTO) - SUM(VRCUSTO) AS VRRENTA,
        		CDTIPOCUSTO, NMTIPOCUSTO, IDCUSFOPRECO, SUM(CUSTOUNIT) AS CUSTOUNIT,
        		ROUND(((ROUND((SUM(VRCUSTO)/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2)/DECODE(VRUNITVEND, 0, 1, VRUNITVEND)) * 100) , 2) AS PERCCUS,
        		ROUND((((ROUND((SUM(VRCUSTO)/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2)/DECODE(VRUNITVEND, 0, 1, VRUNITVEND)) * 100)*-1), 2) + 100 AS PERCLUCR
        	FROM (
        		SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
        				CASE I.VRUNITVEND 
        					WHEN 0 THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0)) 
        					ELSE I.VRUNITVEND END AS VRUNITVEND, 
        				SUM(I.QTPRODVEND) AS QTPRODVEND, 
        				SUM((TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) * M.VRPEALPRODIT / 100) AS VRIMPOSTO,
        				SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
        				SUM(CUSTO_COMPOSICAO(I.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, I.QTPRODVEND, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
        				:TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO, :TIPOCUSTO AS IDCUSFOPRECO, PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO,
        				ROUND(((SUM(CUSTO_COMPOSICAO(I.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, I.QTPRODVEND, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)))/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2) AS CUSTOUNIT
        			FROM ITEMVENDA I
        				JOIN PRODUTO P
                            ON I.CDPRODUTO = P.CDPRODUTO
                           		AND I.NRORG = P.NRORG
        				JOIN PRODUTO PV
                            ON P.NRORG = PV.NRORG
        				JOIN ITVENDAIMPOS M
                        	ON I.CDFILIAL = M.CDFILIAL
                           		AND I.CDCAIXA = M.CDCAIXA
                           		AND I.NRSEQVENDA = M.NRSEQVENDA
                           		AND I.NRSEQUITVEND = M.NRSEQUITVEND
        				JOIN (
        					SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
        							FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, FILOCA.CDPRODTAXAENTR, V.DTENTRVENDA
        						FROM VENDA V
                                  	JOIN (
        								SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, 
        										FILO.NRORG, FILO.CDPRODTAXASERV, FILO.CDPRODTAXAENTR
                                           	FROM CAIXA C
                                           		JOIN (
        											SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV, L.CDPRODTAXAENTR
                                                    	FROM LOJA L
                                                    		JOIN (
        														SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                                             		FROM FILIAL F
                                                            		WHERE ((INSTR(:CDFILIAL, F.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                              			AND F.NRORG = :NRORG
        													) FI
                                                      			ON L.CDFILIAL = FI.CDFILIAL
                                                     				AND L.NRORG = FI.NRORG 
                                                   		WHERE ((INSTR(:CDLOJA, L.CDFILIAL||L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
        										) FILO
                                             		ON C.CDFILIAL = FILO.CDFILIAL
        												AND C.CDLOJA = FILO.CDLOJA
        												AND C.NRORG = FILO.NRORG
        							) FILOCA
                                    	ON V.CDCAIXA = FILOCA.CDCAIXA
        									AND V.CDLOJA = FILOCA.CDLOJA
        									AND V.CDFILIAL = FILOCA.CDFILIAL
        									AND V.NRORG = FILOCA.NRORG
        						WHERE V.IDSITUVENDA = 'O'
                                   	AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
        				) FILOCAVE
                            ON FILOCAVE.CDFILIAL = M.CDFILIAL
        						AND FILOCAVE.CDCAIXA = M.CDCAIXA
        						AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
        			WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
        				AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
        				AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
        				AND PV.NRORG = :NRORG
        			GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, 
        				I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO,
        				PV.CDPRODUTO, PV.NMPRODUTO
            
        		UNION
            
        		SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
        				CASE I.VRUNITVEND 
        					WHEN 0 THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0)) 
        					ELSE I.VRUNITVEND END AS VRUNITVEND, 
        				0 AS QTPRODVEND, 0 AS VRIMPOSTO, 0 AS VRTOTAL,
        				SUM(CUSTO_COMPOSICAO(M.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, M.QTITVENDAEST, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
        				:TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO , :TIPOCUSTO AS IDCUSFOPRECO, PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO, 0 AS CUSTOUNIT
        			FROM ITEMVENDA I
        				JOIN PRODUTO P
                            ON I.CDPRODUTO = P.CDPRODUTO
                           		AND I.NRORG = P.NRORG
        				JOIN PRODUTO PV
                            ON P.NRORG = PV.NRORG
        				JOIN ITEMVENDAEST M
                            ON I.CDFILIAL = M.CDFILIAL
        						AND I.CDCAIXA = M.CDCAIXA
        						AND I.NRSEQVENDA = M.NRSEQVENDA
        						AND I.NRSEQUITVEND = M.NRSEQUITVEND
        				JOIN (
        					SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
                                       FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, FILOCA.CDPRODTAXAENTR, V.DTENTRVENDA
        						FROM VENDA V
                                  	JOIN (
        								SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, 
        										FILO.NRORG, FILO.CDPRODTAXASERV, FILO.CDPRODTAXAENTR
                                           	FROM CAIXA C
                                           		JOIN (
        											SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV, L.CDPRODTAXAENTR
                                                    	FROM LOJA L
                                                    		JOIN (
        														SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                                             		FROM FILIAL F
                                                            		WHERE ((INSTR(:CDFILIAL, F.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                              			AND F.NRORG = :NRORG
        													) FI
                                                      			ON L.CDFILIAL = FI.CDFILIAL
                                                     				AND L.NRORG = FI.NRORG 
                                                   		WHERE ((INSTR(:CDLOJA, L.CDFILIAL||L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
        										) FILO
                                             		ON C.CDFILIAL = FILO.CDFILIAL
        												AND C.CDLOJA = FILO.CDLOJA
        												AND C.NRORG = FILO.NRORG
        							) FILOCA
                                    	ON V.CDCAIXA = FILOCA.CDCAIXA
        									AND V.CDLOJA = FILOCA.CDLOJA
        									AND V.CDFILIAL = FILOCA.CDFILIAL
        									AND V.NRORG = FILOCA.NRORG
        						WHERE V.IDSITUVENDA = 'O'
                                   	AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
        				) FILOCAVE
                            ON FILOCAVE.CDFILIAL = M.CDFILIAL
        						AND FILOCAVE.CDCAIXA = M.CDCAIXA
        						AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
        			WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
        				AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
        				AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
        				AND PV.NRORG = :NRORG
        			GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA,
        				I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO,
        				PV.CDPRODUTO, PV.NMPRODUTO
        	)
        	GROUP BY CDFILIAL, NMFILIAL, CDLOJA, NMLOJA, CDPRODUTO, CDARVPROD, NMPRODUTO, VRUNITVEND, 
        			CDTIPOCUSTO, NMTIPOCUSTO, IDCUSFOPRECO, CDPRODUTOAVO, NMPRODUTOAVO
        ORDER BY CDFILIAL ASC, CDLOJA ASC, VRRENTA DESC
    ";
    
    const GET_RENTABILIDADE_PRODUTO_SEM_IMPOSTO = "
        SELECT CDFILIAL||' - '||NMFILIAL AS LABELFILIAL,
        		CDLOJA||' - '||NMLOJA AS LABELLOJA,
        		CDFILIAL, NMFILIAL, CDLOJA, NMLOJA, CDPRODUTO, CDARVPROD, NMPRODUTO, VRUNITVEND, CDPRODUTOAVO, NMPRODUTOAVO,
        		SUM(QTPRODVEND) AS QTPRODVEND, 
        		0 AS VRIMPOSTO,
        		SUM(VRTOTAL) AS VRTOTAL,
        		SUM(VRCUSTO) AS VRCUSTO,
        		SUM(VRTOTAL) - SUM(VRCUSTO) AS VRRENTA,
        		CDTIPOCUSTO, NMTIPOCUSTO, IDCUSFOPRECO, SUM(CUSTOUNIT) AS CUSTOUNIT,
        		ROUND(((ROUND((SUM(VRCUSTO)/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2)/DECODE(VRUNITVEND, 0, 1, VRUNITVEND)) * 100), 2) AS PERCCUS,
        		ROUND((((ROUND((SUM(VRCUSTO)/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2)/DECODE(VRUNITVEND, 0, 1, VRUNITVEND)) * 100)*-1), 2) + 100 AS PERCLUCR
        	FROM (
        		SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
        				CASE I.VRUNITVEND 
        					WHEN 0 THEN (I.VRUNITVEND + NVL(I.VRACRITVEND, 0)) 
        					ELSE I.VRUNITVEND END AS VRUNITVEND, 
        				SUM(I.QTPRODVEND) AS QTPRODVEND, 
        				0 AS VRIMPOSTO,
        				SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
        				SUM(CUSTO_COMPOSICAO(I.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, I.QTPRODVEND, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
        				:TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO , :TIPOCUSTO AS IDCUSFOPRECO, PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO,
        				ROUND(((SUM(CUSTO_COMPOSICAO(I.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, I.QTPRODVEND, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)))/DECODE(SUM(NVL(QTPRODVEND, 1)), 0, 1, SUM(NVL(QTPRODVEND, 1)))), 2) AS CUSTOUNIT
        			FROM ITEMVENDA I
        				JOIN PRODUTO P
                            ON I.CDPRODUTO = P.CDPRODUTO
                           		AND I.NRORG = P.NRORG
        				JOIN PRODUTO PV
                            ON P.NRORG = PV.NRORG
        				JOIN (
        					SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
                                       FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, FILOCA.CDPRODTAXAENTR, V.DTENTRVENDA
        						FROM VENDA V
                                  	JOIN (
        								SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV, FILO.CDPRODTAXAENTR
                                           	FROM CAIXA C
                                           		JOIN (
        											SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV, L.CDPRODTAXAENTR
                                                    	FROM LOJA L
                                                    		JOIN (
        														SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                                             		FROM FILIAL F
                                                            		WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
                                                              			AND F.NRORG = :NRORG 
        													) FI
                                                      			ON L.CDFILIAL = FI.CDFILIAL
                                                     				AND L.NRORG = FI.NRORG 
                                                   		WHERE ((INSTR(:CDLOJA, L.CDFILIAL||L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
        										) FILO
                                             		ON C.CDFILIAL = FILO.CDFILIAL
        												AND C.CDLOJA = FILO.CDLOJA
        												AND C.NRORG = FILO.NRORG
        							) FILOCA
                                    	ON V.CDCAIXA = FILOCA.CDCAIXA
        									AND V.CDLOJA = FILOCA.CDLOJA
        									AND V.CDFILIAL = FILOCA.CDFILIAL
        									AND V.NRORG = FILOCA.NRORG
        						WHERE V.IDSITUVENDA = 'O'
                                   	AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
        				) FILOCAVE
                            ON FILOCAVE.CDFILIAL = I.CDFILIAL
        						AND FILOCAVE.CDCAIXA = I.CDCAIXA
        						AND FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
        			WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0 ) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
        				AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
        				AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
        				AND PV.NRORG = :NRORG
        			GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, 
        				P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO, PV.CDPRODUTO, PV.NMPRODUTO
            
        		UNION
            
        		SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO,
        				CASE I.VRUNITVEND 
        					WHEN 0 THEN (I.VRUNITVEND + NVL(I.VRACRITVEND,0)) 
        					ELSE I.VRUNITVEND END AS VRUNITVEND, 
        				0 AS QTPRODVEND, 0 AS VRIMPOSTO, 0 AS VRTOTAL,
        				SUM(CUSTO_COMPOSICAO(M.CDPRODUTO, FILOCAVE.CDFILIAL, FILOCAVE.CDFILIAL, :TIPOCUSTO, M.QTITVENDAEST, FILOCAVE.CDLOJA, FILOCAVE.DTENTRVENDA)) AS VRCUSTO,
        				:TIPOCUSTO AS CDTIPOCUSTO, :TIPOCUSTO AS NMTIPOCUSTO , :TIPOCUSTO AS IDCUSFOPRECO, PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO, 0 AS CUSTOUNIT
        			FROM ITEMVENDA I
        				JOIN PRODUTO P
                        	ON I.CDPRODUTO = P.CDPRODUTO
                           		AND I.NRORG = P.NRORG
        				JOIN PRODUTO PV
                            ON P.NRORG = PV.NRORG
        				JOIN ITEMVENDAEST M
                            ON I.CDFILIAL = M.CDFILIAL
                           		AND I.CDCAIXA = M.CDCAIXA
                           		AND I.NRSEQVENDA = M.NRSEQVENDA
                           		AND I.NRSEQUITVEND = M.NRSEQUITVEND
        				JOIN (
        					SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, 
                                       FILOCA.NMFILIAL, FILOCA.NRORG, FILOCA.CDPRODTAXASERV, FILOCA.CDPRODTAXAENTR, V.DTENTRVENDA
        						FROM VENDA V
                                  	JOIN (
        								SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDPRODTAXASERV, FILO.CDPRODTAXAENTR
                                           	FROM CAIXA C
                                           		JOIN (
        											SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV, L.CDPRODTAXAENTR
                                                    	FROM LOJA L
                                                    		JOIN (
        														SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                                             		FROM FILIAL F
                                                            		WHERE ((INSTR(:CDFILIAL, F.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                                              			AND F.NRORG = :NRORG
        													) FI
                                                      			ON L.CDFILIAL = FI.CDFILIAL
                                                     				AND L.NRORG = FI.NRORG 
                                                   		WHERE ((INSTR(:CDLOJA, L.CDFILIAL||L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
        										) FILO
                                             		ON C.CDFILIAL = FILO.CDFILIAL
        												AND C.CDLOJA = FILO.CDLOJA
        												AND C.NRORG = FILO.NRORG
        							) FILOCA
                                    	ON V.CDCAIXA = FILOCA.CDCAIXA
        									AND V.CDLOJA = FILOCA.CDLOJA
        									AND V.CDFILIAL = FILOCA.CDFILIAL
        									AND V.NRORG = FILOCA.NRORG
                                WHERE V.IDSITUVENDA = 'O'
                                   	AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
        				) FILOCAVE
                            ON FILOCAVE.CDFILIAL = M.CDFILIAL
        						AND FILOCAVE.CDCAIXA = M.CDCAIXA
        						AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
        			WHERE (((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF))) OR (P.CDARVPROD LIKE :PRODNIV)) OR (:TCDPRODUTO = 'T'))
        				AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
        				AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
        				AND PV.NRORG = :NRORG
        			GROUP BY FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, I.CDPRODUTO, 
        				P.CDARVPROD, P.NMPRODUTO, I.VRUNITVEND, I.VRACRITVEND, :TIPOCUSTO,
        				PV.CDPRODUTO, PV.NMPRODUTO
        	)
        	WHERE QTPRODVEND <> 0
        	GROUP BY CDFILIAL, NMFILIAL, CDLOJA, NMLOJA, CDPRODUTO, CDARVPROD, NMPRODUTO, VRUNITVEND, CDTIPOCUSTO, 
        			NMTIPOCUSTO, IDCUSFOPRECO, CDPRODUTOAVO, NMPRODUTOAVO
        ORDER BY CDFILIAL ASC, CDLOJA ASC, VRRENTA DESC
    ";
    
}